HDU 4352 XHXJ's LIS (数位DP+LIS+状态压缩)

题意:给定一个区间,让你求在这个区间里的满足LIS为 k 的数的数量。

析:数位DP,dp[i][j][k] 由于 k 最多是10,所以考虑是用状态压缩,表示 前 i 位,长度为 j,状态为 k的数量有多少,再结合nlogn的LIS,

就能搞定这个题目了。

代码如下:

#pragma comment(linker, "/STACK:1024000000,1024000000")
#include <cstdio>
#include <string>
#include <cstdlib>
#include <cmath>
#include <iostream>
#include <cstring>
#include <set>
#include <queue>
#include <algorithm>
#include <vector>
#include <map>
#include <cctype>
#include <cmath>
#include <stack>
//#include <tr1/unordered_map>
#define freopenr freopen("in.txt", "r", stdin)
#define freopenw freopen("out.txt", "w", stdout)
using namespace std;
//using namespace std :: tr1;

typedef long long LL;
typedef pair<int, int> P;
const int INF = 0x3f3f3f3f;
const double inf = 0x3f3f3f3f3f3f;
const LL LNF = 0x3f3f3f3f3f3f;
const double PI = acos(-1.0);
const double eps = 1e-8;
const int maxn = 1e6 + 5;
const LL mod = 1e9 + 7;
const int N = 1e6 + 5;
const int dr[] = {-1, 0, 1, 0, 1, 1, -1, -1};
const int dc[] = {0, 1, 0, -1, 1, -1, 1, -1};
const char *Hex[] = {"0000", "0001", "0010", "0011", "0100", "0101", "0110", "0111", "1000", "1001", "1010", "1011", "1100", "1101", "1110", "1111"};
inline LL gcd(LL a, LL b){  return b == 0 ? a : gcd(b, a%b); }
inline int gcd(int a, int b){  return b == 0 ? a : gcd(b, a%b); }
int n, m;
const int mon[] = {0, 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31};
const int monn[] = {0, 31, 29, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31};
inline int Min(int a, int b){ return a < b ? a : b; }
inline int Max(int a, int b){ return a > b ? a : b; }
inline LL Min(LL a, LL b){ return a < b ? a : b; }
inline LL Max(LL a, LL b){ return a > b ? a : b; }
inline bool is_in(int r, int c){
    return r >= 0 && r < n && c >= 0 && c < m;
}

LL dp[25][12][1200];
int a[25];
int k;

LL dfs(int pos, int num, int s, bool is, bool ok){
    if(!pos)  return k == num;
    if(num > k)  return 0;
    LL &ans = dp[pos][k][s];
    if(!ok && ans >= 0)  return ans;

    LL res = 0;
    int n = ok ? a[pos] : 9;
    for(int i = 0; i <= n; ++i){
        if(is && !i)  res += dfs(pos-1, num, s, is, ok && i == n);
        else if((1<<i) > s)  res += dfs(pos-1, num+1, s|(1<<i), is && !i, ok && i == n);
        else if((1<<i)&s)  res += dfs(pos-1, num, s, is && !i, ok && i == n);
        else for(int j = i+1; j <= 9; ++j)
                if((1<<j)&s){  res += dfs(pos-1, num, (s^(1<<j))|(1<<i), is && !i, ok && i == n);  break; }

    }
    if(!ok)  ans = res;
    return res;
}

LL solve(LL n){
    int len = 0;
    while(n){
        a[++len] = n % 10;
        n /= 10;
    }
    return dfs(len, 0, 0, true, true);
}

int main(){
    memset(dp, -1, sizeof dp);
    int T;  cin >> T;
    for(int kase = 1; kase <= T; ++kase){
        LL n, m;
        scanf("%I64d %I64d %d", &m, &n, &k);
        printf("Case #%d: %I64d
", kase, solve(n) - solve(m-1));
    }
    return 0;
}
原文地址:https://www.cnblogs.com/dwtfukgv/p/5947300.html